/* get the CCTK datatype definitions */
#include "cctk_Types.h"

#ifdef CCODE
#define CCTK_ARGUMENTS CCTK_CARGUMENTS
#define _CCTK_ARGUMENTS _CCTK_CARGUMENTS
#define DECLARE_CCTK_ARGUMENTS DECLARE_CCTK_CARGUMENTS
#endif

#ifdef FCODE
#define CCTK_ARGUMENTS CCTK_FARGUMENTS
#define _CCTK_ARGUMENTS _CCTK_FARGUMENTS
#define DECLARE_CCTK_ARGUMENTS DECLARE_CCTK_FARGUMENTS
#endif

#ifdef THORN_IS_CartGrid3D
#include "CartGrid3D_arguments.h"
#define CCTK_FARGUMENTS CARTGRID3D_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_CARTGRID3D_FARGUMENTS
#define CCTK_CARGUMENTS CARTGRID3D_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_CARTGRID3D_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_CARTGRID3D_CARGUMENTS
#endif

#ifdef THORN_IS_Time
#include "Time_arguments.h"
#define CCTK_FARGUMENTS TIME_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_TIME_FARGUMENTS
#define CCTK_CARGUMENTS TIME_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_TIME_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_TIME_CARGUMENTS
#endif

#ifdef THORN_IS_PUGHSlab
#include "PUGHSlab_arguments.h"
#define CCTK_FARGUMENTS PUGHSLAB_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_PUGHSLAB_FARGUMENTS
#define CCTK_CARGUMENTS PUGHSLAB_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_PUGHSLAB_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_PUGHSLAB_CARGUMENTS
#endif

#ifdef THORN_IS_Einstein
#include "Einstein_arguments.h"
#define CCTK_FARGUMENTS EINSTEIN_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_EINSTEIN_FARGUMENTS
#define CCTK_CARGUMENTS EINSTEIN_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_EINSTEIN_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_EINSTEIN_CARGUMENTS
#endif

#ifdef THORN_IS_BenchADM
#include "BenchADM_arguments.h"
#define CCTK_FARGUMENTS BENCHADM_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_BENCHADM_FARGUMENTS
#define CCTK_CARGUMENTS BENCHADM_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_BENCHADM_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_BENCHADM_CARGUMENTS
#endif

#ifdef THORN_IS_PUGH
#include "PUGH_arguments.h"
#define CCTK_FARGUMENTS PUGH_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_PUGH_FARGUMENTS
#define CCTK_CARGUMENTS PUGH_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_PUGH_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_PUGH_CARGUMENTS
#endif

#ifdef THORN_IS_PUGHReduce
#include "PUGHReduce_arguments.h"
#define CCTK_FARGUMENTS PUGHREDUCE_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_PUGHREDUCE_FARGUMENTS
#define CCTK_CARGUMENTS PUGHREDUCE_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_PUGHREDUCE_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_PUGHREDUCE_CARGUMENTS
#endif

#ifdef THORN_IS_Boundary
#include "Boundary_arguments.h"
#define CCTK_FARGUMENTS BOUNDARY_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_BOUNDARY_FARGUMENTS
#define CCTK_CARGUMENTS BOUNDARY_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_BOUNDARY_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_BOUNDARY_CARGUMENTS
#endif

#ifdef THORN_IS_IOBasic
#include "IOBasic_arguments.h"
#define CCTK_FARGUMENTS IOBASIC_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_IOBASIC_FARGUMENTS
#define CCTK_CARGUMENTS IOBASIC_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_IOBASIC_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_IOBASIC_CARGUMENTS
#endif

#ifdef THORN_IS_Cactus
#include "Cactus_arguments.h"
#define CCTK_FARGUMENTS CACTUS_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_CACTUS_FARGUMENTS
#define CCTK_CARGUMENTS CACTUS_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_CACTUS_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_CACTUS_CARGUMENTS
#endif

#ifdef THORN_IS_IDLinearWaves
#include "IDLinearWaves_arguments.h"
#define CCTK_FARGUMENTS IDLINEARWAVES_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_IDLINEARWAVES_FARGUMENTS
#define CCTK_CARGUMENTS IDLINEARWAVES_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_IDLINEARWAVES_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_IDLINEARWAVES_CARGUMENTS
#endif

#ifdef THORN_IS_IOUtil
#include "IOUtil_arguments.h"
#define CCTK_FARGUMENTS IOUTIL_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_IOUTIL_FARGUMENTS
#define CCTK_CARGUMENTS IOUTIL_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_IOUTIL_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_IOUTIL_CARGUMENTS
#endif

#ifdef THORN_IS_IOASCII
#include "IOASCII_arguments.h"
#define CCTK_FARGUMENTS IOASCII_FARGUMENTS
#define DECLARE_CCTK_FARGUMENTS DECLARE_IOASCII_FARGUMENTS
#define CCTK_CARGUMENTS IOASCII_CARGUMENTS
#define DECLARE_CCTK_CARGUMENTS DECLARE_IOASCII_CARGUMENTS
#define USE_CCTK_CARGUMENTS USE_IOASCII_CARGUMENTS
#endif

